<?php
/************* Librarie */
function error_message($message){
	fwrite(STDERR,"FAILED  - $message\n");
	$date = date("Y-m-d H:i:s");
	@mkdir(dirname('/var/log/ecatp'));
	file_put_contents('/var/log/esia/watchdog-ecatp.log',"$date - FAILED : $message\n", FILE_APPEND );
}

function success_message($message){
	fwrite(STDOUT,"SUCCESS - $message\n");
}

/************* Functions de callbacks */
//General configuration
define('PROCESS_RUN',"/etc/init.d/ecatp-server.sh restart");
define('PROCESS_PID_FILE','/var/run/ecatp-server.pid');

//Check_process configuration
define('PROCESS_MEM_MAX',20);
define('PROCESS_MEM_RANGE',10);
define('PROCESS_CPU_MAX',95);
define('PROCESS_CPU_RANGE',90);
define('PROCESS_TMP_FILE',"/tmp/ecatp/watchdog_ecatp");

//Check_establiched configuration
define("REMOTE_PORT",2080);
define("PROGRAM","gesa_server");
define("MAX_TIME_TASK_SEND",305);

//Check_descriptors_nbr
define('PROCESS_FD_LIMIT',900);

//Check_unity
define('UNITY_FILE_LIST','/tmp/ecatp/gesa.list');
define('PLUGINS_DIR','/usr/local/esia/plugins');
define('UNITY_ECATP_SCRIPT','check_gesa');
define('UNITY_CHECK_TIMEOUT',30);

//function check process nb,memory and cpu
function check_process(){
	$pid=@trim(file_get_contents(PROCESS_PID_FILE));
	if(empty($pid)){
		error_message('Process no started or unable to read pid in '.PROCESS_PID_FILE);
		return false;
	}

	$output=trim(exec('netstat -tanp|grep '.REMOTE_PORT.'|grep ESTABLISHED|tr -s " " "/"|cut -d"/" -f7|uniq'));
	if( !empty($output) && $output != $pid ){
		error_message("Error service bad pid");
		exec("kill -9 $output");
		return false;
	}

	$output=exec("ps -h --pid $pid -o %cpu,%mem".'|tr -s " " " "');

	if( empty($output) ){
		error_message("Process $pid not found");
		return false;
	}

	$parsing=explode(" ",trim($output));
	$p_cpu=$parsing[0];
	$p_mem=$parsing[1];

	if($p_mem > PROCESS_MEM_MAX){
		error_message("Memory usage $p_mem > max (".PROCESS_MEM_MAX.')');
		return false;
	}

	if($p_cpu > PROCESS_CPU_MAX){
		error_message("CPU usage $p_cpu > max (".PROCESS_CPU_MAX.')');
		return false;
	}

	$content_file=@file_get_contents(PROCESS_TMP_FILE);
	if(!empty($content_file)) $first_data=json_decode($content_file,true);

	if(isset($first_data["pid"])&&$first_data["pid"]==$pid){
		$cpu_rising = $p_cpu - $first_data["cpu"];
		$mem_rising = $p_mem - $first_data["mem"];

		if( $mem_rising > PROCESS_MEM_RANGE ){
			error_message("MEM rising $mem_rising > max (".PROCESS_MEM_RANGE.')');
			return false;
		}

		if( $cpu_rising > PROCESS_CPU_RANGE ){
			error_message("CPU rising $cpu_rising > max (".PROCESS_CPU_RANGE.')');
			return false;
		}
	}
	else{
		$data = array("pid"=>$pid,"cpu"=>$p_cpu,"mem"=>$p_mem);
		file_put_contents(PROCESS_TMP_FILE,json_encode($data));
	}

	success_message("PROCESS:No problem for process $pid cpu_usage = $p_cpu% mem_usage = $p_mem%");
	return true;
}

function check_http_response(){
        include('/usr/local/esia/public_html/esia.conf.php');
        $dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
        $dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);

        $request = "SELECT COUNT(service_plugin_id) FROM esia_services WHERE service_last_stdout like '%WebSocket.class.php%';";

        if( $result = $dbconnection->query($request) ){
                $nb = $result->fetchColumn();
                if( $nb > 0 ) {
                        error_message("$nb services in state WebSocket.class.php 1295:Unable to get http Response");
                        return false;
                }
                else {
                        success_message("0 services in http response error");
                }
        }
        else {
                error_message("Unable to get services states");
        }
        return true;
}

//function check connection established
function check_established(){
	$program=PROGRAM;
	$port=REMOTE_PORT;

	$output=exec('netstat -tanp 2>/dev/null|grep '.PROGRAM.'|tr -s " " " "|cut -d " " -f4,7|grep '.REMOTE_PORT,$all_output);
	if(empty($output)){
		error_message("Client '$program' not connected on remote port $port");
		return false;
	}

	success_message("CONNECTED on $output");
	return true;
}

function check_unity(){
	//Récupération des gesas connectés
	sleep(1); //Eviter les erreurs entre 2 checks
	//On test la gesa
	$line1=exec(PLUGINS_DIR.'/'.UNITY_ECATP_SCRIPT." -G 0000 -C check-ecatp -t ".UNITY_CHECK_TIMEOUT,$output,$ret);
    $return = true;
    //Exemple sortie
        //last_send:0
        //lastclean: 0
        //task_size:0
        //NumberUnity:0
    $lastsend=0;
    $tasksize=0;
    $unity=0;
    if($ret == 0)
    {
        foreach( $output as $line)
        {
		    if(preg_match('#last_send:([0-9]*)#',$line,$regs))
            {
                $lastsend = $regs[1];
            }
		    elseif(preg_match('#last_size:([0-9]*)#',$line,$regs))
            {
                $tasksize = $regs[1];
            }
		    elseif(preg_match('#unity:([0-9]*)#',$line,$regs))
            {
                $unity = $regs[1];
            }
	    }
        $time = time();
        if($lastsend == 0 && $tasksize ==0 && $unity == 0)
        {
            //le démon vient de redémarrer
           success_message("OK: is first start or no deployed plateform");
           $return = true;
        }
        elseif($unity > 0 && $lastsend==0)
        {
            //la unity vient de se connecter mais pas encore de tâche exécuté
           success_message("OK: first connect unity");
           $return = true; 
        }
        elseif( ($time - $lastsend)  > MAX_TIME_TASK_SEND)
        {
            //la dernière tache date de matusalem
            $return = false;
            error_message("Task are to old");
        }
        elseif( $unity == 0 && $lastsend != 0)
        {
            //Démon blocké
            error_message("ecatp-server are freeze");
            $return = false;
        } 
        elseif($unity == 0)
        {
            //Aucun unity connectée et le système réponds gesa unrechable en boucle
            error_message("All unity are disconnect");
            $return = false;
        } 
    }
    else
    {
        //erreur de connexion au serveur websocket
        error_message("WEBSocket Connexion error");
         $return = false;
    }  
    success_message("OK: ALL test are success: Unity number: $unity, last exec: $lastsend, tasksize: $tasksize");
	return $return;
}

function check_descriptors_nbr(){
        $pid=@trim(file_get_contents(PROCESS_PID_FILE));
        if(empty($pid)){
                error_message('Process no started or unable to read pid in '.PROCESS_PID_FILE);
                return false;
        }

        $file_descriptors = @scandir("/proc/$pid/fd");
        if( $file_descriptors === FALSE ){
                error_message("Unable to scan /proc/$pid/fd directory");
                return false;
        }
        $total_fd = count($file_descriptors);
        if( $total_fd > PROCESS_FD_LIMIT ){
                error_message("Process has $total_fd descriptors files (>".PROCESS_FD_LIMIT.')');
                return false;
        }

        success_message("FD:Process has $total_fd descriptors files (<".PROCESS_FD_LIMIT.')');
        return true;
}

function restart_daemon(){
	exec(PROCESS_RUN. " 2> /dev/null 1>/dev/null",$output,$ret);
	$output=implode("\n",$output);
	if($ret==0)success_message("Restart daemon success");
	else error_message("Unable to restart daemon");
	return ($ret==0);
}

/************* Configuration du daemon */
$callbacks_functions = array();
$callbacks_functions["check_process"]="restart_daemon";
$callbacks_functions["check_established"]="restart_daemon";
$callbacks_functions["check_descriptors_nbr"]="restart_daemon";
//$callbacks_functions["check_http_response"]="restart_daemon";
$callbacks_functions["check_unity"]="restart_daemon";

/************* RUN */
$ret=0;
foreach($callbacks_functions as $check => $resolve){
	if(!call_user_func($check)){
		if(call_user_func($resolve)) $ret=call_user_func($check);
		else $ret=1;
	}
	else $ret=0;
	echo "\n";
}
exit($ret);
?>
